% This program calls ZIGEEfit.m to fit ZI-overdispersed poisson model(ZIOP)
% to appleroot data. 

% Define global variables which can be used in subroutines
global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
global Y ID ID2 N2 N BMAT GMAT BINN2 ERRDIST2 MU2LINK PLINK CORSTRUCT MIXPCORSTR;
global VARFUNCTION; 


path(path,'../program')
load 'appleroot.dat';           % load the data set
ID=[1:size(appleroot,1)]';
N=size(ID,1);
N2=N;
Y=appleroot(:,3);
photo=appleroot(:,1);
trt=appleroot(:,5);
conc=appleroot(:,2);

log_conc=log(conc);
photomat=fac(photo);   % call fac to make a matrix of indicators for all levels except photo=1
concmat=fac(conc);
trtmat=fac(trt,0);

ID2=zeros(N,1);
for i=1:N2;
  ID2(ID==i)=[1:size(ID(ID==i),1)]';
end;

photo8=1-photomat;
photo16=photomat;
logconc8=log_conc.*photo8;
logconc16=log_conc.*photo16;

GMAT=[photo8,photo16];                     % covariate matrix used in modelling mixing probabilities
BMAT=[photo8,photo16,logconc8,logconc16];  % covariate matrix used in modelling mean

betainit=[1.8,2.0,.092,-.16]';             % set initial values of parameters
gammainit=[0 0]';
alphabinit=0;
alphaginit=0;
phiinit=1;

glmlab;                         %call glmlab which needs to be downloaded and installed in your computer
PLINK='logit';                  %define link function for mixing probabilities and Poisson means
MU2LINK='log';
ERRDIST2='poisson';             %let the second component of ZI mixture model has Poisson dist. (ZIP)             
BINN2=ones(N,1);
VARFUNCTION='identity';         %VARFUNCTION=variance function
CORSTRUCT='indep';              %define the working correlation structure     
MIXPCORSTR='indep';

diary appleroot_ZIOP.diary


%%%%%%%%%call the subroutine of ZIGEEfit to fit data using the ES algorithm incorprating GEE
 
[beta,gamma,alphab,alphag,phi]=ZIGEEfit(gammainit,betainit,alphabinit,alphaginit,phiinit)

diary off

