%SUBROUTINE CALLED BY APPLEROOT_ZIOP.m and WHITEFLY.m. 
%THIS PART FINDS ESTIMATED PARAMETERS BY THE ES ALGORITHM INCOPORATING GEE
%and ALSO CALCULATES VARIANCE-COVARIANCE MATRIX OF PARAMETERS 
%BETA AND GAMMA ARE REGRESSION PARAMETERS CORRESPONDING TO MEAN AND MIXING PROBABILITIES 
%PHI IS DISPERSION PARAMETER AND ALPHAb IS CORRELATION PARAMETER ASSOCIATED WITH
%THE SECOND COMPONENT OF ZI MODELS
%ALPHAg IS CORRELATION PARAMETER OF THE MIXING MECHANISM, WHICH WE ASSUME ZERO HERE
%u IS THE EXPECTION OF THE MISSING VALUES WE INTRODUCE INTO THE MODEL



function [beta,gamma,alphab,alphag,phi]= ...
  ZIGEEfit(gammainit,betainit,alphabinit,alphaginit,phiinit)

% Define global variables which can be used by other subroutines

global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
global Y ID ID2 N2 N BMAT GMAT BINN2 ERRDIST2 MU2LINK PLINK CORSTRUCT; 
global LINKFUNCTION VARFUNCTION VARFUNCONST MIXPCORSTR;

VARFUNCONST=0;
blah=MIXPCORSTR;

clear paramtrs;[toler,maxits,illctol]=paramtrs;     %load defaults:
BIG=1.0e10;
SMALL=1.0e-10;
converge=0;

phi=phiinit;
beta=betainit
alphab=alphabinit; 
alphag=alphaginit; 

gamma=gammainit
dimgamma=size(gamma,1);
dimbeta=size(beta,1);
if (strcmp(MIXPCORSTR,'indep')) 
  dimalphag=0;
else
  dimalphag=size(alphag,1);
end;
if (strcmp(CORSTRUCT,'indep'))
  dimalphab=0;
else
  dimalphab=size(alphab,1);
end;                             

dimparm=dimgamma+dimbeta+dimalphab+dimalphag+1;     %calculate dimention of parameters
dimparmb=dimbeta+dimalphab+1;
dimparmg=dimgamma+dimalphag;

its=0;
fail=0;
while (its<maxits)
  its=its+1

  betaold=beta;
  gammaold=gamma;
  alphabold=alphab;
  alphagold=alphag;
  phiold=phi;

  blp=BMAT*beta;
  glp=GMAT*gamma;
  p=getmixp(glp);

  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Now compute weights (E step of the ES algorithm)
  
  mu2=getmu2(blp,BINN2);
  u=zeros(N,1); 
  temp= (Y==0).*p;
  fofyij= temp+(1-p).*getf2(Y,mu2,BINN2);  
  u(Y==0,1)= temp(Y==0)./fofyij(Y==0,1);     % expectation of the missing values

  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Now do M step for gamma by glmlab
  
  warning off
  newmodel; 
  clear global YVAR XVARS;
  global YVAR LINKFUNCTION XVARS ERRDISFUNCTION SCALEPAR INC_CONST;
  global OFFSET WEIGHTS DETAILSFILE NAMEXV NAMELIST NAMEYV;
  warning on
  NAMEXV='[';
  for i=1:size(GMAT,2)
    NAMEXV=strcat(NAMEXV,'G'); 
    NAMEXV=strcat(NAMEXV,int2str(i));
    if (i~=size(GMAT,2))
      NAMEXV=strcat(NAMEXV,',');
    end;
  end;
  NAMEXV=strcat(NAMEXV,']');
  NAMEYV='[y]';
  NAMELIST=['Constant'];
  for i=1:size(GMAT,2)-1
    NAMELIST=str2mat(NAMELIST,['Gvar ',num2str(i)]);
  end;

  INC_CONST=0;
  
  YVAR=[u,ones(N,1)];
  LINKFUNCTION=PLINK;
  XVARS=GMAT;
  ERRDISFUNCTION='binoml';
  OFFSET=zeros(size(YVAR,1),1);
  WEIGHTS=ones(size(YVAR,1),1);
  
  [gamma, fits, resids, glmcovgamma, covd, devlist]=glmfit;
  gamma=gamma(:,1);

  

%%%%%%%%%%%%%%S step of the ES algorithm to solve beta, alpha and phi

  geeits=0;
  geefail=1;
  while (geeits<maxits)
    geeits=geeits+1

    udot=zeros(dimbeta+dimalphab+1,1);
    idot=zeros(dimbeta+dimalphab+1,dimbeta+dimalphab+1); 
    uudot=idot;
    
    for i=1:N2;

      n1i=size(ID(ID==i,:),1);
      q=n1i*(n1i+1)/2;
      mui=getmui(beta,i);
      vmui=getvmui(mui);
      ri=getri(alphab,n1i);
      if (strcmp(ERRDIST2,'binoml'))
      aisqrt=diag( sqrt(vmui./BINN2(ID==i)) );
      yi=Y(ID==i)./BINN2(ID==i);
      else
      aisqrt=diag( sqrt(vmui) );
      yi=Y(ID==i);
      end;
      vi=phi*aisqrt*ri*aisqrt;
      viinv=inv(vi);   
      f1i=yi-mui;
      si=vech(f1i*f1i');
      sigmai=vech(vi);
      fi=[f1i;si-sigmai];
      wi=[viinv, zeros(n1i,q); zeros(q,n1i), eye(q,q)];   
      dmui=getdmui(beta,i);
      dvmui=getdvmui(mui);
      dmuidbetat=kron(ones(1,dimbeta),dmui).*BMAT(ID==i,:);
      di22=zeros(q,dimalphab+1);
      ti22=di22;

      %%%%%%%%%%%%%%%%%%compute dvi w.r.t. alpha(u)
      for j=1:dimalphab;
        dvij=getdvidalpha(n1i,alphab,vmui,j,phi);
        dviinvj = -viinv*dvij*viinv;
        di22(:,j)=vech(dviinvj);
        ti22(:,j)=vech(dvij);
      end;
      di22(:,dimalphab+1)=vech(-(1/phi)*viinv);
      ti22(:,dimalphab+1)=vech((1/phi)*vi);
      ti12=zeros(q,dimbeta);
      for b=1:dimbeta;
        dvidbetab= phi*(diag( (1/2)*vmui.^(-1/2).*dvmui.*dmuidbetat(:,b))*...
          ri*aisqrt + aisqrt*ri*diag( (1/2)*vmui.^(-1/2).*dvmui.*...
          dmuidbetat(:,b) ));
        ti12(:,b)=vech(dvidbetab);
      end;
      di=[dmuidbetat, zeros(n1i,dimalphab+1); zeros(q,dimbeta), di22];
      hi=diag([1-u(ID==i);vech((1-u(ID==i))*(1-u(ID==i))')]);
      ui=di'*wi*hi*fi;
      ti=[dmuidbetat, zeros(n1i,dimalphab+1); ti12, ti22];
      udot=udot+ui;
      idot=idot-di'*wi*hi*ti;
      end

    idotinv=inv(idot);
    updatevec=idotinv*udot;
    maxscore=max(abs(udot))
    maxchange=max(abs(updatevec))

    beta = beta - updatevec(1:dimbeta);
    alphab = alphab - updatevec(dimbeta+1:dimbeta+dimalphab);
    phi = phi - updatevec(end);
 
    maxparm=max([abs(beta); abs(alphab)]);
    minparm=min([abs(beta); abs(alphab)]);
    if (maxparm>BIG | minparm<SMALL | rcond(idot)<SMALL)        % not converging
      geeits=maxits+1;
    end
    if (maxscore<toler & maxchange<toler)
      geefail=0
      geeits=maxits+1;
    end  

end                                % gee iterations in M step for beta,phi

  if (geefail)
    converge=0
    its=maxits+1;
  end;
  
  maxchange=max(abs([beta-betaold;gamma-gammaold;alphab-alphabold;phi-phiold]))
  relchange= norm([beta-betaold;gamma-gammaold;alphab-alphabold;phi-phiold])/...
    norm([beta;gamma;alphab;phi])
  
  if (relchange<toler)
    converge=1
    its=maxits+1;
    
    beta_con=beta;
    gamma_con=gamma;
    alphab_con=alphab;
    alphag_con=alphaginit;
    phi_con=phi;
    end;
  
end;    %While



%%%%%%%% calculate variance-covariance matrix by calling functions of getSandVnew() and getdsdparm()

vs=getSandVnew(gamma_con, beta_con, alphag_con, alphab_con, phi_con);  
s=vs(:,dimparm+1);   
score=getdsdparm(s,gamma_con, beta_con, alphag_con, alphab_con, phi_con);  
v_part=zeros(dimparm,dimparm);
for i=1:dimparm;
for j=1:dimparm;
v_part(i,j)=vs(i,j);
end;
end;
v_part;        
sinv=inv(score);
stderr=sqrt(diag(sinv*v_part*(sinv)'))   % sinv*v_part*(sinv)' is var-cov matrix
