% used in calculating variance and covariance of estimated parms 
% called by ZIGEEfit
%BETA AND GAMMA ARE REGRESSION PARAMETERS CORRESPONDING TO MEAN AND MIXING PROBABILITIES 
%PHI IS DISPERSION PARAMETER AND ALPHAb IS CORRELATION PARAMETER ASSOCIATED WITH
%THE SECOND COMPONENT OF ZI MODELS
%ALPHAg IS CORRELATION PARAMETER OF THE MIXING MECHANISM, WHICH WE ASSUME ZERO HERE
%S and V ARE TWO COMPONENTS USED IN CALCULATING VAR-COV MATRIX OF PARAMETERS


function [vs]=getSandVnew(gamma, beta, alpha_g, alpha_b, phi)

global Y ID ID2 N2 N BMAT GMAT BINN2 ERRDIST2 MU2LINK PLINK CORSTRUCT; 
global LINKFUNCTION VARFUNCTION VARFUNCONST MIXPCORSTR;

dimgamma=size(gamma,1);
dimbeta=size(beta,1);
if (strcmp(MIXPCORSTR,'indep'))
  dimalpha_g=0;
else
  dimalpha_g=size(alpha_g,1);
end;
if (strcmp(CORSTRUCT,'indep'))
  dimalpha_b=0;
else
  dimalpha_b=size(alpha_b,1);
end; 
dimparm=dimgamma+dimbeta+dimalpha_g+dimalpha_b+1;            % parameter dimension

gamma_part=zeros(dimgamma,1);
beta_part=zeros(dimbeta,1);
alpha_b_part=zeros(dimalpha_b+1,1);
alpha_g_part=zeros(dimalpha_g,1);
gamma_part1=zeros(dimgamma,1);
beta_part1=zeros(dimbeta,1);
alpha_b_part1=zeros(dimalpha_b+1,1);
alpha_g_part1=zeros(dimalpha_g,1);
s=zeros(dimparm,1);
v_part=zeros(dimparm,dimparm);

  blp=BMAT*beta;
  glp=GMAT*gamma;
  p=getmixp(glp);
  
  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%Now compute weights (E step of the ES algorithm)
  
  mu2=getmu2(blp,BINN2);
  u=zeros(N,1);
  %z=log(0.3); 
  temp= (Y==0).*p;
  fofyij= temp+(1-p).*getf2(Y,mu2,BINN2,phi);
  u(Y==0,1)= temp(Y==0)./fofyij(Y==0,1);
  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   
     for i=1:N2;
   
      ni=size(ID(ID==i,:),1);
      q=ni*(ni+1)/2;
      pi=p(ID==i);
      ui=u(ID==i);
      vpi=pi.*(1-pi);
      mui=getmui(beta,i);
      ri_b=getri(alpha_b,ni);
      tempcs=CORSTRUCT;
      CORSTRUCT=MIXPCORSTR;
      ri_g=getri(alpha_g,ni);
      CORSTRUCT=tempcs;
      vmui_b=getvmui(mui);
      one=ones(ni,1);
      npi=pi.*(one-pi);  
      vmui_g=getvmui(npi);
      if (strcmp(ERRDIST2,'poisson') | strcmp(ERRDIST2,'normal'))
      yi=Y(ID==i);
      aisqrt_b=diag( sqrt(vmui_b) );
      end;
      if (strcmp(ERRDIST2,'binoml'))
      yi=Y(ID==i)./BINN2(ID==i);
      aisqrt_b=diag( sqrt(vmui_b./BINN2(ID==i) ));
      end;
      aisqrt_gamma=diag( sqrt(vmui_g) );
      aisqrt_alphag=diag( sqrt(vpi) );
      ui11=aisqrt_gamma*ri_g*aisqrt_gamma;    %  for gamma
      vi11=phi*aisqrt_b*ri_b*aisqrt_b;        %  for beta  
      ui22=aisqrt_alphag*ri_g*aisqrt_alphag;  %  for alphag 
      ui11inv=inv(ui11);
      vi11inv=inv(vi11);
      ui22inv=inv(ui22);
      
      
      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for gamma part in s vector
      
      lp= GMAT(ID==i,:)*gamma; 
      dpi=exp(lp)./((1+exp(lp)).^2); 
      dpidgammat=kron(ones(1,dimgamma),dpi).*GMAT(ID==i,:);
      ditg=[dpidgammat]';
      
      gamma_part=gamma_part+ditg*ui11inv*(ui-pi);
      gamma_part1=ditg*ui11inv*(ui-pi);
      

      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for beta part in s vector
      
      dmui=getdmui(beta,i);
      dvmui=getdvmui(mui);
      dmuidbetat=kron(ones(1,dimbeta),dmui).*BMAT(ID==i,:);
      ditb=[dmuidbetat]';
      hib=diag(1-u(ID==i));
      
      beta_part=beta_part+ditb*vi11inv*hib*(yi-mui); 
      beta_part1=ditb*vi11inv*hib*(yi-mui);
      
        
        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for alpha_gamma part in s vector

        if (~strcmp(MIXPCORSTR,'indep'))
        
        f1i=ui-pi;
        ti=vech(f1i*f1i');
        taui=vech(ui22);
        fi=[f1i;ti-taui];
        dvpi=1-2*pi;
        dmuidgammat=kron(ones(1,dimgamma),vpi).*GMAT(ID==i,:);
        di22alphag=zeros(q,dimalpha_g);
        ei22=di22alphag;
        %compute dvi w.r.t. alphag(j)
        for j=1:dimalpha_g;
          tempcs=CORSTRUCT;
          CORSTRUCT=MIXPCORSTR;
          dvij=getdvidalpha(ni,alpha_g,vpi,j,1);
          CORSTRUCT=tempcs;          
          dviinvj = -ui22inv*dvij*ui22inv;
          di22alphag(:,j)=vech(dviinvj);
          ei22(:,j)=vech(dvij);
        end;
        di22alphagt=[di22alphag]';
        ui22new=eye(q,q);
        
         alpha_g_part=alpha_g_part+di22alphagt*ui22new*(ti-taui);
         alpha_g_part1=di22alphagt*ui22new*(ti-taui);
 
        end;

      %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% for alpha_beta part in s vector

      if (~strcmp(CORSTRUCT,'indep'))
      f2i=yi-mui;
      si=vech(f2i*f2i');
      sigmai=vech(vi11); 
      di22alphab=zeros(q,dimalpha_b+1);
      ti22=di22alphab;
      ui22new=eye(q,q);
      %compute dvi w.r.t. alpha_b(u)
      for j=1:dimalpha_b;
        dvij=getdvidalpha(ni,alpha_b,vmui_b,j,phi);
        dviinvj = -vi11inv*dvij*vi11inv;
        di22alphab(:,j)=vech(dviinvj);
        ti22(:,j)=vech(dvij);
      end;
      di22alphab(:,dimalpha_b+1)=vech(-(1/phi)*vi11inv);
      di22alphabt=[di22alphab]';
      hialphab=diag(vech((1-u(ID==i))*(1-u(ID==i))'));
          
       alpha_b_part=alpha_b_part+di22alphabt*ui22new*hialphab*(si-sigmai);
       alpha_b_part1=di22alphabt*ui22new*hialphab*(si-sigmai);       

    else
     f2i=yi-mui;
      si=vech(f2i*f2i');
      sigmai=vech(vi11); 
      di22alphab=zeros(q,dimalpha_b+1);
      ti22=di22alphab;
      ui22new=eye(q,q);
    di22alphab(:,dimalpha_b+1)=vech(-(1/(phi^2))*vi11inv);
    di22alphabt=[di22alphab]';
    hialphab=diag(vech((1-u(ID==i))*(1-u(ID==i))'));
    
       alpha_b_part=alpha_b_part+di22alphabt*ui22new*hialphab*(si-sigmai);
       alpha_b_part1=di22alphabt*ui22new*hialphab*(si-sigmai); 
    
    end;
    
              
if ((~strcmp(MIXPCORSTR,'indep')) & (~strcmp(CORSTRUCT,'indep')) )                 
s1=[gamma_part1;beta_part1;alpha_g_part1;alpha_b_part1];
v_part=v_part+s1*s1';   
end;
 
if (strcmp(MIXPCORSTR,'indep'))  
s1=[gamma_part1;beta_part1;alpha_b_part1];
v_part=v_part+s1*s1'; 
end;   
    
end;         % i=1:N2   

         
if ((~strcmp(MIXPCORSTR,'indep')) & (~strcmp(CORSTRUCT,'indep')) )                
 s=[gamma_part;beta_part;alpha_g_part;alpha_b_part];  
 vs=[v_part,s];
 end;
 
 if (strcmp(MIXPCORSTR,'indep')) 
 s=[gamma_part;beta_part;alpha_b_part]; 
 vs=[v_part,s];
 end;    
 
