% function used to calculate alphahat using MOM estimators
%based on different working correlation structures
%called by ZIGEEfit

function [alpha]=getalphamom(mu,phi,dimbeta,wts)

global ID BMAT N N2 Y CORSTRUCT BINN2;

if (strcmp(CORSTRUCT,'indep')) 
  alpha=0;

elseif (strcmp(CORSTRUCT,'exch')) 
  alpha=0;
  Nstar=0;
  for i=1:N2;
    wtsi=wts(ID==i);
    binni=BINN2(ID==i);
    mui=mu(ID==i);
    yi=Y(ID==i);
    ni=size(ID(ID==i,:),1);
    ei=(yi-mui)./sqrt(getvmui(mui./binni).*binni);
    ei=ei.*sqrt(wtsi);
    alpha = alpha+ sum(sum(ei*ei'))-sum(ei.^2);
    Nstar=Nstar+sum(sum(sqrt(wtsi)*sqrt(wtsi)'))-sum(wtsi);
  end;
  alpha=alpha/phi/(Nstar-dimbeta);

elseif (strcmp(CORSTRUCT,'onedep') | strcmp(CORSTRUCT,'ar1')) 
  alpha=0;
  K1=0;
  for i=1:N2;
    ni=size(ID(ID==i,:),1);
    ei=(Y(ID==i)-mu(ID==i))./sqrt(getvmui(mu(ID==i)./BINN2(ID==i)).*BINN2(ID==i));
    ei=ei.*sqrt(wts(ID==i));
    %ei=(Y(ID==i)-mu(ID==i))./sqrt(getvmui(mu(ID==i)));
    for j=1:ni-1;
      alpha=alpha+ei(j)*ei(j+1);
    end;
    K1=K1+(ni-1);
  end;
  alpha=alpha/phi/(K1-dimbeta);

elseif (strcmp(CORSTRUCT,'unspec')) 
  n1=size(ID(ID==1,:),1);
  alphamat=zeros(n1,n1);
  for i=1:N2;
    ni=size(ID(ID==i,:),1);
    ei=(Y(ID==i)-mu(ID==i))./sqrt(getvmui(mu(ID==i)./BINN2(ID==i)).*BINN2(ID==i));
    ei=ei.*sqrt(wts(ID==i));
    alphamat=alphamat+ei*ei';
  end;
  alpha=vech(alphamat(1:end-1,2:end))./phi./(N2-dimbeta);
end;  

