% Calculates derivative of mean vector of current GLM 
% where beta is the regression vector
% MU2LINK is the link function in modelling the 2nd component of ZI models
% called by ZIGEEfit

function [dmui]=getdmui(beta,i)

global  ID BMAT N MU2LINK;

lp=BMAT(ID==i,:)*beta;
if (strcmp(MU2LINK,'logit')) 
  dmui=exp(lp)./((1+exp(lp)).^2);

elseif (strcmp(MU2LINK,'log')) 
  dmui=exp(lp);

elseif (strcmp(MU2LINK,'identity')) 
  dmui=ones(size(lp));

elseif (strcmp(MU2LINK,'inverse')) 
  dmui= -1*ones(size(lp))./(lp.^2);
end;

