% Calculates derivative of variance matrix with respect to alpha
% under different working correlation structure 
%called by ZIGEEfit

function [dvi]=getdvidalpha(ni,alpha,vmui,alphaindex,phi)

global  N CORSTRUCT;

dri=zeros(ni,ni);
dimalpha=size(alpha,1);
if alphaindex<=dimalpha

if (strcmp(CORSTRUCT,'exch'))
  dri=ones(ni,ni)-eye(ni);

elseif (strcmp(CORSTRUCT,'ar1'))
  for s=1:ni;
    for t=1:ni;
      dri(s,t)=abs(s-t)*alpha^(abs(s-t)-1);
    end;
  end;

elseif (strcmp(CORSTRUCT,'onedep'))
  for s=1:ni;
    for t=1:ni;
      if (abs(s-t)==1)
        dri(s,t)=1;
      else 
        dri(s,t)=0;
      end;
    end;
  end;

elseif (strcmp(CORSTRUCT,'unspec'))
  count=0;
  for s=1:ni;
    for t=s+1:ni;
      count=count+1;
      if (count==alphaindex)
        dri(s,t)=1;
        dri(t,s)=1;
      end;
    end;
  end;
end;

aisqrt=diag( sqrt(vmui) );
dvi=phi*aisqrt*dri*aisqrt;
elseif alphaindex>dimalpha
  ri=getri(alpha,ni);
  aisqrt=diag( sqrt(vmui) );
  dvi=aisqrt*ri*aisqrt;
end;
