% Calculates derivative of variance function. 
% where mui is the mean vector for the ith cluster
% global variable VARFUNCTION is variance function
% called by ZIGEEfit


function [dvmui]=getdvmui(mui)

global  N VARFUNCTION;

if (strcmp(VARFUNCTION,'constant')) 
  dvmui=zeros(size(mui));

elseif (strcmp(VARFUNCTION,'identity')) 
  dvmui=ones(size(mui));

elseif (strcmp(VARFUNCTION,'binomial')) 
  dvmui=ones(size(mui))-2*mui;

elseif (strcmp(VARFUNCTION,'square')) 
  dvmui= 2*mui;

end;

