% computes conditional density f_2(y_ij,beta,sigma_2|b_i)
% mucond is conditional mean
% global variable ERRDIST2 is distribution of the 2nd component in ZI models 
% called by the routine of ZIGEEfit

function [f]=getf2cond(y,mucond,bin,phi)

global ERRDIST2 ;

if strcmp(ERRDIST2,'poisson')
  f=poisspdf(y,mucond);

elseif strcmp(ERRDIST2,'binoml')
f=(gamma(bin+1)./gamma(y+1)./gamma(bin-y+1)).* (mucond./bin).^y .* (1-mucond./bin).^(bin-y);

elseif strcmp(ERRDIST2,'normal')
  f=normpdf(y,mucond,sqrt(phi));   

else
  error('Invalid ERRDIST2 in getf2cond');
end;

