% computes mixing probability from linear predictor based on the chosen link
% function for the mixing probability (PLINK)
% called by ZIGEEfit 

function [p]=getmixp(lp)

global PLINK;

if strcmp(PLINK,'logit')
  p=exp(lp)./(1+exp(lp));
elseif strcmp(PLINK,'probit')
  p=normcdf(lp);
end;

