% computes means of the 2nd component distribution 
% based on the chosen link function for that distribution (MU2LINK)
% called by ZIGEEfit

function [mu]=getmu2(lp,bin)

global MU2LINK ;

if strcmp(MU2LINK,'logit')
  mu=bin.*exp(lp)./(1+exp(lp));

elseif strcmp(MU2LINK,'probit')
  mu=bin.*normcdf(lp);

elseif strcmp(MU2LINK,'log')
  mu=exp(lp);

elseif strcmp(MU2LINK,'inverse')
  mu=1./lp;

elseif strcmp(MU2LINK,'identity')
  mu=lp;

end;

