% Calculates mean vector of current GLM 
% where beta is the regression vector
% MU2LINK is the link function in modelling the 2nd component of ZI models 
% called by ZIGEEfit

function [mui]=getmui(beta,i)

global ID BMAT N MU2LINK;

lp=BMAT(ID==i,:)*beta;

if (strcmp(MU2LINK,'logit')) 
  mui=exp(lp)./(1+exp(lp));

elseif (strcmp(MU2LINK,'log')) 
  mui=exp(lp);

elseif (strcmp(MU2LINK,'identity')) 
  mui=lp;

elseif (strcmp(MU2LINK,'inverse')) 
  mui=ones(size(lp))./lp;

elseif (strcmp(MU2LINK,'cloglog')) 
  mui=ones(size(lp))-exp(-exp(lp));

end;

