% Calculates correlation matrix of current GLM 
% where alpha is the association vector, ni is the ith cluster size
% global variable CORSTRUCT is the working correlation structure
% called by ZIGEEfit


function [ri]=getri(alpha,ni)

global N CORSTRUCT;

ri=eye(ni,ni);     % default is independence structure

if (strcmp(CORSTRUCT,'exch'))
  ri=alpha*(ones(ni,ni)-eye(ni,ni))+eye(ni,ni);

elseif (strcmp(CORSTRUCT,'ar1'))
  for j=1:ni;
    for k=1:ni;
      ri(j,k)=alpha^abs(j-k);
    end;
  end;

elseif (strcmp(CORSTRUCT,'onedep'))
  ri=eye(ni,ni);
  for j=1:ni;
    ri(j,j+1)=alpha;
    ri(j+1,j)=alpha;
  end;

elseif (strcmp(CORSTRUCT,'unspec'))
  count=0;
  for j=1:ni;
    for k=j+1:ni;
      count=count+1;
      ri(j,k)=alpha(count);
      ri(k,j)=alpha(count);
    end;
  end;
end;
  
